OpenVDB: NineteenPointStencil< GridT, IsSafe > Class Template Reference

OpenVDB 6.1.0

Public Types | Public Member Functions | Static Public Attributes | Protected Attributes | Friends | List of all members
NineteenPointStencil< GridT, IsSafe > Class Template Reference

`#include <Stencils.h>`

Inherits BaseStencil< NineteenPointStencil< GridT, IsSafe >, GridT, IsSafe >.

## Public Types
typedef GridT | GridType
typedef GridT::TreeType | TreeType
typedef GridType::ValueType | ValueType
typedef tree::ValueAccessor< const TreeType, IsSafe > | AccessorType
typedef std::vector< ValueType > | BufferType
typedef BufferType::iterator | IterType

## Public Member Functions
| NineteenPointStencil (const GridType &grid)
template<int i, int j, int k>
unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center. More...
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. More...
void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known. More...
void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos. More...
const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil. More...
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil. More...
int | size ()
| Return the size of the stencil buffer. More...
ValueType | median () const
| Return the median value of the current stencil. More...
ValueType | mean () const
| Return the mean value of the current stencil. More...
ValueType | min () const
| Return the smallest value in the stencil buffer. More...
ValueType | max () const
| Return the largest value in the stencil buffer. More...
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil. More...
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil. More...
bool | intersects (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue. More...
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed. More...
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil. More...

## Static Public Attributes
static const int | SIZE = 19

## Protected Attributes
const GridType * | mGrid
Coord | mCenter

## Friends
template<typename , typename , bool >
class | BaseStencil

## Member Typedef Documentation

## ◆ AccessorType

typedef tree::ValueAccessor<const TreeType, IsSafe> AccessorType
| inherited

## ◆ BufferType

typedef std::vector<ValueType> BufferType
| inherited

## ◆ GridType

typedef GridT GridType

## ◆ IterType

typedef BufferType::iterator IterType
| inherited

## ◆ TreeType

typedef GridT::TreeType TreeType

## ◆ ValueType

typedef GridType::ValueType ValueType

## Constructor & Destructor Documentation

## ◆ NineteenPointStencil()

NineteenPointStencil | ( | const GridType & | grid | ) |
| inline

## Member Function Documentation

## ◆ accessor()

const AccessorType& accessor | ( |  | ) | const
| inlineinherited

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ getCenterCoord()

const Coord& getCenterCoord | ( |  | ) | const
| inlineinherited

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

const ValueType& getCenterValue | ( |  | ) | const
| inlineinherited

Return the value at the center of the stencil.

## ◆ getValue() [1/2]

const ValueType& getValue | ( | unsigned int | pos = `0` | ) | const
| inlineinherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ getValue() [2/2]

const ValueType& getValue | ( |  | ) | const
| inlineinherited

Return the value at the specified location relative to the center of the stencil.

## ◆ grid()

const GridType& grid | ( |  | ) | const
| inlineinherited

Return a const reference to the grid from which this stencil was constructed.

## ◆ intersects()

bool intersects | ( | const ValueType & | isoValue = `zeroVal<ValueType>()` | ) | const
| inlineinherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ max()

ValueType max | ( |  | ) | const
| inlineinherited

Return the largest value in the stencil buffer.

## ◆ mean()

ValueType mean | ( |  | ) | const
| inlineinherited

Return the mean value of the current stencil.

## ◆ median()

ValueType median | ( |  | ) | const
| inlineinherited

Return the median value of the current stencil.

## ◆ min()

ValueType min | ( |  | ) | const
| inlineinherited

Return the smallest value in the stencil buffer.

## ◆ moveTo() [1/4]

void moveTo | ( | const Coord & | ijk | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## ◆ moveTo() [2/4]

void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue
| ) |  |
| inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stnecil center
  centerValue | Value of the center element of the stencil

## ◆ moveTo() [3/4]

void moveTo | ( | const IterType & | iter | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Note
  This version is slightly faster than the one above, since the center voxel's value is read directly from the iterator.

## ◆ moveTo() [4/4]

void moveTo | ( | const Vec3< RealType > & | xyz | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## ◆ pos()

unsigned int pos | ( |  | ) | const
| inline

Return linear offset for the specified stencil point relative to its center.

## ◆ setValue()

void setValue | ( | const ValueType & | value | ) |
| inlineinherited

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

int size | ( |  | ) |
| inlineinherited

Return the size of the stencil buffer.

## Friends And Related Function Documentation

## ◆ BaseStencil

friend class BaseStencil
| friend

## Member Data Documentation

## ◆ mCenter

Coord mCenter
| protectedinherited

## ◆ mGrid

const GridType* mGrid
| protectedinherited

## ◆ SIZE

const int SIZE = 19
| static

The documentation for this class was generated from the following file:

- Stencils.h